import React, { Component } from 'react';
import PropTypes from 'prop-types';
import ListTasks from './list-tasks';
import AddTask from './add-task';
import 'whatwg-fetch';
import { createTODOStore } from './store';

class App extends Component {
  constructor(props) {
    super(props);
  }    
  
  componentWillMount() { 
    fetch('/todo')
      .then(response => response.json())
      .then(tasks => this.initializeStore(tasks));
  }                                        
  
  initializeStore(tasks) {
    this.store = createTODOStore(tasks);

    this.unsubscribe = this.store.subscribe(() => this.forceUpdate());
    this.forceUpdate();
  }

  callWillUnmount() {
    this.unsubscribe();
  }                    
  
  getChildContext() {
    return {
      store: this.store || { getState: function() { return []; }}
    }
  }
  
  render() { 
    return (
      <div>             
        <div><AddTask /></div>
        <span className="left"><ListTasks name="Pending Tasks" pending={true}/></span>
        <span className="right"><ListTasks name="Completed Tasks" pending={false}/></span>
      </div>
    );
  }
}
                          
App.childContextTypes = { store: PropTypes.object.isRequired }
                   
export default App;