import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { createTogglePending } from './store';

class ListTasks extends Component {
  constructor(props) {
    super(props);
    
    this.name = props.name;
    this.pending = props.pending;
    this.mark = this.pending ? 'Complete' : 'Move to Pending';
  }
  
  toggleStatus(id) { 
    this.context.store.dispatch(createTogglePending(id));
  }
  
  render() {    
    const { store } = this.context;

    const tasks = store.getState()
      .filter(task => task.pending == this.pending);

    return (
      <div>
        <h2>{ this.name }</h2>
        <ol>
          {
            tasks.map((task, index) =>
              <li key={index.toString()}>{ task.name} <button onClick={ () => this.toggleStatus(task.id) }>{this.mark}</button></li>
            )          
          }
        </ol>
      </div>
    );
  }
}                      

ListTasks.contextTypes = {
  store: PropTypes.object
}
                   
export default ListTasks;